﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Windows.Forms;
using System.Threading;

namespace DllImjectionTest {
    class DllInjection {
        int pid = 0;//挿入先のプロセスID
        UIntPtr hDll = UIntPtr.Zero;//挿入したDLLのハンドル
        
        [DllImport("kernel32.dll",SetLastError=true)]
        static extern UIntPtr OpenProcess(
            UInt32 dwDesiredAccess, // アクセスフラグ
            bool bInheritHandle,    // ハンドルの継承オプション
            Int32 dwProcessId);     // プロセス識別子

        [DllImport("kernel32.dll",SetLastError=true)]
        static extern UIntPtr VirtualAllocEx(
            UIntPtr hProcess,    // 割り当てたいメモリを保持するプロセス
            UIntPtr lpAddress,   // 割り当てたい開始アドレス
            UInt32 dwSize,      // 割り当てたい領域のバイト単位のサイズ
            UInt32 flAllocationType,  // 割り当てのタイプ
            UInt32 flProtect);  // アクセス保護のタイプ


        [DllImport("kernel32.dll",SetLastError=true)]
        static extern bool WriteProcessMemory(
            UIntPtr hProcess,     // プロセスのハンドル
            UIntPtr lpBaseAddress,// 書き込み開始アドレス
            string lpBuffer,     // データバッファ
            UIntPtr nSize,       // 書き込みたいバイト数
            out IntPtr lpNumberOfBytesWritten); // 実際に書き込まれたバイト数
        [DllImport("kernel32.dll", SetLastError =true)]
        static extern UIntPtr CreateRemoteThread(
            UIntPtr hProcess,          // 新しいスレッドを稼働させるプロセスを識別するハンドル
            UIntPtr lpThreadAttributes,// スレッドのセキュリティ属性へのポインタ(LPSECURITY_ATTRIBUTES)
            UInt32 dwStackSize,       // 初期のスタックサイズ (バイト数)
            UIntPtr lpStartAddress,   // スレッド関数へのポインタ(LPTHREAD_START_ROUTINE)
            UIntPtr lpParameter,       // 新しいスレッドの引数へのポインタ
            UInt32 dwCreationFlags,   // 作成フラグ
            out IntPtr lpThreadId);   // 取得したスレッド識別子へのポインタ

        [DllImport("kernel32.dll",SetLastError=true)]
        public static extern UIntPtr GetProcAddress(
            UIntPtr hModule,    // DLL モジュールのハンドル
            string lpProcName);// 関数名

        [DllImport("kernel32.dll",SetLastError=true)]
        public static extern UIntPtr GetModuleHandle(
            string lpModuleName);   // モジュール名
           
        //[DllImport("kernel32", SetLastError = true, ExactSpelling = true)]
        [DllImport("kernel32")]
        internal static extern Int32 WaitForSingleObject(
            UIntPtr hHandle,        // オブジェクトのハンドル
            UInt32 dwMilliseconds);// タイムアウト時間

        [DllImport("kernel32.dll")]
        public static extern Int32 CloseHandle(
            UIntPtr hObject);  // オブジェクトのハンドル

        [DllImport("kernel32.dll")]
        private static extern bool GetExitCodeThread(
            UIntPtr hThread,      // スレッドのハンドル
            ref UIntPtr lpExitCode);   // 終了ステータス
 
        [DllImport("kernel32.dll")]
        static extern bool VirtualFreeEx(
            UIntPtr hProcess,  // 解放したいメモリを保持するプロセス
            UIntPtr lpAddress, // 解放したいメモリ領域の開始アドレス
            UInt32 dwSize,     // 解放したいメモリ領域のバイト単位のサイズ
            UInt32 dwFreeType);  // 解放操作のタイプ

        public bool Load(string dllName, string exeName) {
            bool result = false;
            var len = dllName.Length + 1;
            var pMem = UIntPtr.Zero;//挿入先で確保したメモリのポインタ
            var hProcess = UIntPtr.Zero;//プロセスハンドル
            var hThread = UIntPtr.Zero;//スレッドハンドル
            
            //挿入先のプロセス取得
            var p = Process.GetProcessesByName(exeName);
            if (p.Length <= 0) {
                MessageBox.Show(string.Format("ERROR GetProcesByName() {0}が見つかりません。", exeName));
                return result;
            }
            pid = p[0].Id;//Unloadする際に、同一のプロセスを対象とするためプロセスIDを記憶する

            
            //プロセスハンドルの取得
            UInt32 PROCESS_ALL_ACCESS = 0x1F0FFF;
            hProcess = OpenProcess(PROCESS_ALL_ACCESS, false, pid);
            if (hProcess == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR OpenProcess()に失敗しました。 error={0}", error));
                goto end;
            }

            //パラメータ用の文字列を置くための領域を挿入先に確保する
            UInt32 MEM_COMMIT = 0x1000;
            UInt32 PAGE_EXECUTE_READWRITE = 0x40;
            pMem = (UIntPtr)VirtualAllocEx(hProcess, UIntPtr.Zero, (uint)len, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
            if (pMem == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR VirtualAllocEx()に失敗しました。 error={0}", error));
                goto end;
            }
            IntPtr bytesout;
            //確保した挿入先の領域にDLL名を書き込む
            WriteProcessMemory(hProcess, pMem, dllName, (UIntPtr)len, out bytesout);
            
            //LoadLibraryのアドレスを取得する（karnel32は、どのプロセスでも同じ領域に居るので、他のプロセス上でも同一のアドレスとなる）
            UIntPtr pAddr = GetProcAddress(GetModuleHandle("kernel32.dll"), "LoadLibraryA");
            if (pAddr == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR GetProcAddress()に失敗しました。 error={0}", error));
                goto end;
            }

            //挿入先でLoadLibraryを呼び出す
            hThread = CreateRemoteThread(hProcess, UIntPtr.Zero, 0, pAddr, pMem, 0, out bytesout);
            if (hThread == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR CreateRemoteThread() error={0}",error));
                goto end;
            }
            //注入スレッドが終了するまで待機（DllMailから帰るまで待つ）
            UInt32 INFINITE = 0xFFFFFFFF;//シグナル状態になるまで待機
            WaitForSingleObject(hThread,INFINITE);

            //スレッド(LoadLibrary)の戻り値(ハンドル):を取得する
            if (GetExitCodeThread(hThread,ref hDll)) {
                if (hDll != UIntPtr.Zero) {
                    result = true;//成功
                }
            }



        end:
            //スレッドハンドルのクローズ
            if (hThread != UIntPtr.Zero) {
                CloseHandle(hThread);
            }
            //確保したメモリの開放
            if(pMem!= UIntPtr.Zero){
                VirtualFreeEx(hProcess, pMem, 0, 0x8000);
            }
            //プロセスハンドルのクローズ
            if (hProcess != UIntPtr.Zero) {
                CloseHandle(hProcess);
            }
            //*******************************
            //64ビットの場合のポインタ修正
            //*******************************
            if (result && IntPtr.Size == 8) {
                UInt64 d = (UInt64)hDll;
                d = d | (UInt64)0x000007fe00000000;
                hDll = (UIntPtr)d;
            }

            return result;
        }
        public bool Unload() {
            if (hDll == UIntPtr.Zero)
                return false;



            bool result = false;
            
            var hProcess = UIntPtr.Zero;//プロセスハンドル
            var hThread = UIntPtr.Zero;//スレッドハンドル

            //プロセスハンドルの取得
            UInt32 PROCESS_ALL_ACCESS = 0x1F0FFF;
            hProcess = OpenProcess(PROCESS_ALL_ACCESS, false, pid);
            if (hProcess == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR OpenProcess()に失敗しました。error={0}",error));
                goto end;
            }
            //FreeLibraryのアドレスを取得する（karnel32は、どのプロセスでも同じ領域に居るので、他のプロセス上でも同一のアドレスとなる）
            UIntPtr pAddr = GetProcAddress(GetModuleHandle("kernel32.dll"), "FreeLibrary");
            if (pAddr == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR GetProcAddress()に失敗しました。 errir={0}", error));
                goto end;
            }
            
            //挿入先でFreeLibraryを呼び出す
            IntPtr bytesout;
            hThread = CreateRemoteThread(hProcess, UIntPtr.Zero, 0, pAddr,hDll, 0, out bytesout);
            if (hThread == UIntPtr.Zero) {
                var error = Marshal.GetLastWin32Error();
                MessageBox.Show(string.Format("ERROR CreateRemoteThread() error={0}",error));
                goto end;
            }
            //注入スレッドが終了するまで待機（DllMailから帰るまで待つ）
            UInt32 INFINITE = 0xFFFFFFFF;//シグナル状態になるまで待機
            WaitForSingleObject(hThread, INFINITE);
        end:
            //スレッドハンドルのクローズ
            if (hThread != UIntPtr.Zero) {
                CloseHandle(hThread);
            }
            //プロセスハンドルのクローズ
            if (hProcess != UIntPtr.Zero) {
                CloseHandle(hProcess);
            }
            hDll = UIntPtr.Zero;
            return result;
        }

        //[DllImport("kernel32", SetLastError = true)]
        //static extern UIntPtr LoadLibrary(string lpFileName);

        //[DllImport("kernel32", SetLastError = true)]
        //static extern bool FreeLibrary(UIntPtr hModule);
        //public void Test(string dllName) {
        //    //dllName = "c:\\work\\64.dll";
        //    UIntPtr hDll = LoadLibrary(dllName);
        //    if (hDll == UIntPtr.Zero) {
        //        var error = Marshal.GetLastWin32Error();
        //        MessageBox.Show(string.Format("ERROR LoadLibrary()に失敗しました。error=0x{0:X}", error));
        //    } else {
        //        FreeLibrary(hDll);
        //    }
        //}
    }
}
